/* $VER: 1.1, 1998 Dietmar Eilert. Login/Logoff. */

options results                             /* enable return codes     */

if (left(address(), 6) ~= "GOLDED") then    /* not started by GoldEd ? */

    address 'GOLDED.1'

'LOCK CURRENT RELEASE=4'                    /* lock GUI, gain access   */

if (RC ~= 0) then

    exit

options failat 6                            /* ignore warnings         */

signal on syntax                            /* ensure clean exit       */

/* ------------------------ INSERT YOUR CODE HERE: ------------------- */

'INSERT LINE'

'TEXT STAY T="/**"'
'DOWN'
'INSERT LINE'
'TEXT STAY T=" ** $Revision$"'
'DOWN'
'INSERT LINE'
'TEXT STAY T=" ** $State$"'
'DOWN'
'INSERT LINE'
'TEXT STAY T=" ** $Author$"'
'DOWN'
'INSERT LINE'
'TEXT STAY T=" ** $Locker$"'
'DOWN'
'INSERT LINE'
'TEXT STAY T=" ** $Date$"'
'DOWN'
'INSERT LINE'
'TEXT STAY T=" **"'
'DOWN'
'INSERT LINE'
'TEXT STAY T=" ** $Log:$"'
'DOWN'
'INSERT LINE'
'TEXT STAY T="**/"'

/* ---------------------------- END OF YOUR CODE --------------------- */

'UNLOCK' /* VERY important: unlock GUI */

exit

SYNTAX:

SAY "Sorry, error line" SIGL ":" ERRORTEXT(RC) ":-("

'UNLOCK'

exit

/* /// "rcs_initialize" */

rcs_initialize: procedure expose CONFIG. STRING.

    R = pragma('D', CONFIG.CFG_PATH)

    do forever

        shell

        if (exists("rcs") = 0) then

            'makedir "rcs"'

        if (exists("rcs")) then do

            'echo >RCS_link "RCS"'

            'echo >>RCS_link ""'

            'echo >>RCS_link "ignore: .rcsfreeze.???"'
        end

        shell

        if ((exists("RCS") = 0) | (exists("RCS_link") = 0)) then do

            'REQUEST BODY="' || STRING.sINITERROR || '" BUTTON="' || STRING.sRETRY || '"'

            if (RC ~= 0) then

                call rcs_exit
        end
        else
            leave
    end

    return

/* /// */
/* /// "rcs_login" */

rcs_login: procedure expose CONFIG. STRING.

    if ((exists("rcs:ci") = 0) | (exists("rcs:co") = 0) | (exists("rcs:rcs") = 0) | (exists("rcs:setuprcs") = 0)) then do

        'REQUEST PROBLEM="' || STRING.sMISSING || '"'

        call rcs_exit
    end

    'QUERY $LOGNAME VAR=LOGNAME'

    if (INDEX(LOGNAME, " ") ~= 0) then do

        'REQUEST PROBLEM="' || STRING.sINVALIDNAME || '"'

        LOGNAME = ""
    end

    if ((LOGNAME = "") | (LOGNAME = "0")) then do

        if (VERBOSE = "TRUE") then
            'REQUEST PROBLEM="' || STRING.sLOGINVERBOSE || '"'
        else
            'REQUEST PROBLEM="' || STRING.sLOGIN || '"'

        call rcs_quicklogin
    end

    return

/* /// */
/* /// "rcs_quicklogin" */

rcs_quicklogin: procedure expose CONFIG. STRING.

    'QUERY $LOGNAME VAR=LOGNAME'

    if (INDEX(LOGNAME, " ") ~= 0) then do

        'REQUEST PROBLEM="' || STRING.sINVALIDNAME || '"'

        LOGNAME = ""
    end

    if ((LOGNAME = "") | (LOGNAME = "0")) then do

        do while ((LOGNAME = "") | (LOGNAME = "0"))

            'REQUEST STRING TITLE="Login" VAR=LOGNAME'

            if (RC ~= 0) then do

                'UNLOCK'

                exit
            end

            if (INDEX(LOGNAME, " ") ~= 0) then do

                'REQUEST PROBLEM="' || STRING.sINVALIDNAME || '"'

                LOGNAME = ""
            end
            else if ((LOGNAME = "") | (LOGNAME = "0")) then

                'REQUEST PROBLEM="' || STRING.sANONYMOUS || '"'

            else do

                'SET $LOGNAME "' || LOGNAME || '"'

                'REQUEST STATUS="' || STRING.sLOGGED || ' ' || LOGNAME || '."'

                break
            end
        end
    end

    return

/* /// */
/* /// "rcs_getrevision" */

rcs_getrevision: procedure expose STRING.

    parse arg ARGOLD ARGTITLE

    'REQUEST STRING TITLE="' || substr(ARGTITLE, 2) || '" BODY="' || STRING.sREVISION ||'" OLD="' || ARGOLD || '"'

    if (RC ~= 0) then

        call rcs_exit

    return RESULT

/* /// */
/* /// "rcs_readcfg" */

rcs_readcfg: procedure expose CONFIG. STRING.

    'QUERY PATH VAR=PATH'

    /* find configuration file */

    if (exists(PATH || "RCS_config") = 0) then do

        if (exists(PATH || "RCS_root") = 0) then do

            PATH = pragma('D')

            'EXPAND NAME="' || PATH || '" VAR=PATH'

            if (exists(PATH || "RCS_config") = 0) then do

                if (exists(PATH || "RCS_root") = 0) then do

                    'REQUEST STATUS="' || STRING.sNOPROJECT ||'"'

                    'REQUEST DIR TITLE="' || STRING.sGETDIR ||'" VAR=PATH'

                    if (RC ~= 0) then

                        call rcs_exit

                    'REQUEST STATUS=""'
                end
            end
        end
    end

    'EXPAND NAME="' || PATH || '" VAR=PATH'

    if (exists(PATH || "RCS_root") ~= 0) then do

        call rcs_readlink PATH

        'EXPAND NAME="' || RESULT || '" VAR=PATH'
    end

    if (exists(PATH || "RCS_config") = 0) then do

        'REQUEST PROBLEM="' || STRING.sNOPROJECT || '"'

        call rcs_exit
    end
    else do

        /* read project configuration */

        R = open('CONFIG', PATH || "RCS_config", 'READ')

        if (R = 0) then do

            'REQUEST PROBLEM="' || STRING.sNOCONFIG || '"'

            call rcs_exit
        end
        else do

            CONFIG.CFG_CONFIG   = PATH || "RCS_config"
            CONFIG.CFG_NAME     = ""
            CONFIG.CFG_PATH     = ""
            CONFIG.CFG_COMMENT  = ""
            CONFIG.CFG_SNAPSHOT = ""
            CONFIG.CFG_USERS    = 0
            CONFIG.CFG_LOGIN    = 0
            CONFIG.CFG_FILES    = 0

            do forever

                DATA = readln('CONFIG')

                if (eof('CONFIG')) then do

                    R = close('CONFIG')

                    leave
                end
                else do

                    if (left(DATA, 6) = "[NAME]") then

                        CONFIG.CFG_NAME = readln('CONFIG')

                    else if (left(DATA, 6) = "[PATH]") then

                        CONFIG.CFG_PATH = readln('CONFIG')

                    else if (left(DATA, 10) = "[SNAPSHOT]") then do

                        CONFIG.CFG_SNAPSHOT = readln('CONFIG')
                    end
                    else if (left(DATA, 9) = "[COMMENT]") then do

                        CONFIG.CFG_COMMENT = readln('CONFIG')
                    end

                    else if (left(DATA, 6) = "[USER]") then do

                        USERS = 0

                        do forever

                            DATA = readln('CONFIG')

                            if (eof('CONFIG')) then

                                leave

                            if (length(compress(DATA, " ;")) = 0) then

                                leave

                            else do

                                USERS = USERS + 1

                                CONFIG.CFG_USER.USERS = DATA
                                CONFIG.CFG_WORK.USERS = CONFIG.CFG_PATH
                            end
                        end

                        CONFIG.CFG_USERS = USERS

                    end
                    else if (left(DATA, 6) = "[WORK]") then do

                        USERS = 0

                        do forever

                            DATA = readln('CONFIG')

                            if (eof('CONFIG')) then

                                leave

                            if (length(compress(DATA, " ;")) = 0) then

                                leave

                            else do

                                USERS = USERS + 1

                                CONFIG.CFG_WORK.USERS = DATA
                            end
                        end
                    end
                    else if (left(DATA, 7) = "[FILES]") then do

                        FILES = 0

                        do forever

                            DATA = readln('CONFIG')

                            if (eof('CONFIG')) then

                                leave

                            if (length(compress(DATA, " ;")) = 0) then

                                leave

                            else do

                                FILES = FILES + 1

                                CONFIG.CFG_SETUP.FILES = DATA
                            end
                        end

                        CONFIG.CFG_FILES = FILES
                    end
                end
            end

            /* check user ID */

            'QUERY $LOGNAME VAR=LOGNAME'

            if (CONFIG.CFG_USERS ~= 0) then do

                do USER = 1 to CONFIG.CFG_USERS

                    if (CONFIG.CFG_USER.USER = LOGNAME) then do

                        CONFIG.CFG_LOGIN = USER

                        leave
                    end
                end

            end

            /* new user ? */

            if (CONFIG.CFG_LOGIN = 0) then do

                'REQUEST BODY="' || STRING.sNEWUSER || '" BUTTON="' || STRING.sADDCANCEL || '"'

                if ((RC ~= 0) | (RESULT = 0)) then

                    call rcs_exit

                else do

                    USER = CONFIG.CFG_USERS + 1

                    CONFIG.CFG_USERS     = USER
                    CONFIG.CFG_LOGIN     = USER
                    CONFIG.CFG_USER.USER = LOGNAME
                    CONFIG.CFG_WORK.USER = ""

                    call rcs_createworkdir USER

                    call rcs_savecfg
                end
            end
        end
    end

    return

/* /// */
/* /// "rcs_savecfg" */

rcs_savecfg: procedure expose CONFIG. STRING.

    R = open('CONFIG', CONFIG.CFG_CONFIG, 'WRITE')

    if (R = 0) then

        'REQUEST PROBLEM="' || STRING.sSAVEERR '"'

    else do

        'QUERY DATE VAR=DATE'

        R = writeln('CONFIG', "[NAME]")
        R = writeln('CONFIG', CONFIG.CFG_NAME)
        R = writeln('CONFIG', "")

        R = writeln('CONFIG', "[PATH]")
        R = writeln('CONFIG', CONFIG.CFG_PATH)
        R = writeln('CONFIG', "")

        R = writeln('CONFIG', "[SNAPSHOT]")
        R = writeln('CONFIG', CONFIG.CFG_SNAPSHOT)

        if (CONFIG.CFG_SNAPSHOT ~= "") then

            R = writeln('CONFIG', "")

        R = writeln('CONFIG', "[COMMENT]")
        R = writeln('CONFIG', CONFIG.CFG_COMMENT)

        if (CONFIG.CFG_COMMENT ~= "") then

            R = writeln('CONFIG', "")

        R = writeln('CONFIG', "[USER]")

        if (CONFIG.CFG_USERS ~= 0) then do

            do USER = 1 to CONFIG.CFG_USERS

                R = writeln('CONFIG', CONFIG.CFG_USER.USER)

            end
        end

        R = writeln('CONFIG', "")

        R = writeln('CONFIG', "[WORK]")

        if (CONFIG.CFG_USERS ~= 0) then do

            do USER = 1 to CONFIG.CFG_USERS

                R = writeln('CONFIG', CONFIG.CFG_WORK.USER)

            end
        end

        R = writeln('CONFIG', "")

        R = writeln('CONFIG', "[FILES]")

        if (CONFIG.CFG_FILES ~= 0) then do

            do FILE = 1 to CONFIG.CFG_FILES

                R = writeln('CONFIG', CONFIG.CFG_SETUP.FILE)

            end
        end

        R = close('CONFIG')
    end

    return

/* /// */
/* /// "rcs_exit" */

rcs_exit:

    'UNLOCK'

    exit

    return

/* /// */
/* /// "rcs_createsnapshot" */

rcs_createsnapshot: procedure expose CONFIG. STRING.

    'REQUEST BODY="' || STRING.sSNAPSHOT || '" BUTTON="' || STRING.sCREATEHELPSKIP || '"'

    if ((RC ~= 0) | (RESULT = 0)) then

        call rcs_exit

    if (RESULT = 3) then                             /* DISABLE */

        CONFIG.CFG_SNAPSHOT = ""

    if ((RESULT = 1) | (RESULT = 2)) then do         /* OK, HELP */

        SNAPSHOT = CONFIG.CFG_SNAPSHOT

        if (SNAPSHOT = "") then

            SNAPSHOT = "snapshot"

        if (RESULT = 2) then do

            'REQUEST TITLE="' || SNAPSHOT || '" BODY="' || STRING.sSNAPSHOTHELP || '" BUTTON="' ||STRING.sCREATECANCEL || '"'
        end
        else
            RESULT = 1

        if ((RC = 0) & (RESULT = 1)) then do

            if (INDEX(SNAPSHOT, ":") = 0) then

                SNAPSHOT = CONFIG.CFG_PATH || SNAPSHOT

            'REQUEST STATUS="' || STRING.sCREATINGSNAP ||'"'

            'FILE NEWDIR NAME="' || SNAPSHOT || '"'

            if (exists(SNAPSHOT) = 0) then do

                'REQUEST PROBLEM="' || STRING.sSNAPSHOTERR || '"'

                SNAPSHOT = ""
            end
            else do

                'EXPAND NAME="' || SNAPSHOT || '" VAR=SNAPSHOT'

                if (CONFIG.CFG_FILES ~= 0) then do

                    shell

                    do FILE = 1 to CONFIG.CFG_FILES

                        'copy "' || CONFIG.CFG_PATH || CONFIG.CFG_SETUP.FILE || '" "' || SNAPSHOT || '"'

                        'protect "' || SNAPSHOT || CONFIG.CFG_SETUP.FILE || '" W SUB'
                    end

                    shell
                end
            end
        end
        else
            SNAPSHOT = ""

        CONFIG.CFG_SNAPSHOT = SNAPSHOT
    end

    return

/* /// */
/* /// "rcs_createworkdir" */

rcs_createworkdir: procedure expose CONFIG. STRING.

    parse arg USER

    'REQUEST BODY="' STRING.sWORKDIR ||'" BUTTON="' || STRING.sOK || '"'

    if (RC = 0) then do

        do forever

            'REQUEST DIR SAVE TITLE="' || STRING.sWORKINGDIR || '" PATH="sys:" VAR=PRJWORK'

            if (RC = 0) then do

                'EXPAND NAME="' || PRJWORK || '" VAR=PRJWORK'

                CONFIG.CFG_WORK.USER = PRJWORK

                if (exists(PRJWORK || "rcs_link") = 0) then do

                    if (exists(PRJWORK || "rcs_root") = 0) then do

                        call rcs_savelink USER

                        leave
                    end
                    else
                        'REQUEST PROBLEM="' || STRING.sINUSE || '"'
                end
                else
                    leave
            end
            else
                call rcs_exit
        end
    end

    return

/* /// */
/* /// "rcs_savelink" */

rcs_savelink: procedure expose CONFIG. STRING.

    parse arg USER

    if (USER ~= 0) then do

        PATH = CONFIG.CFG_WORK.USER || 'RCS_root'

        R = open('CONFIG', PATH, 'WRITE')

        if (R = 0) then

            'REQUEST PROBLEM="' || STRING.sLOCALSAVEERR ||'"'

        else do

            R = writeln('CONFIG', "[CONFIG]")

            R = writeln('CONFIG', CONFIG.CFG_PATH)

            R = close('CONFIG')
        end
    end

    return

/* /// */
/* /// "rcs_readlink" */

rcs_readlink: procedure expose CONFIG. STRING.

    parse arg PATH

    R = open('CONFIG', PATH || "RCS_root", 'READ')

    if (R = 0) then do

        'REQUEST PROBLEM="' || STRING.sNOCONFIG || '"'

        call rcs_exit
    end
    else do forever

        DATA = readln('CONFIG')

        if (eof('CONFIG')) then do

            R = close('CONFIG')

            leave
        end

        if (eof('CONFIG')) then

            leave

        if (left(DATA, 8) = "[CONFIG]") then

            PATH = readln('CONFIG')
    end

    return PATH

/* /// */
/* /// "rcs_checkin" */

rcs_checkin: procedure expose CONFIG. STRING.

    parse arg MODE

    REVISION = ""
    LOGMSG   = ""

    if (MODE = "REVISION") then do

        'REQUEST STRING BODY="' || STRING.sREVISION || '" VAR=REVISION'

        if (RC ~= 0) then

            call rcs_exit

        /* RCS doesn't allow spaces (code 32) in identifiers; we use code 160 instead (unbreakable space) */

        if (length(REVISION) ~= 0) then do

            do N = 1 to length(REVISION)

                if (substr(REVISION, N, 1) = " ") then

                    REVISION = overlay(D2C(160), REVISION, N, 1)
            end
        end
    end

   'REQUEST STRING BODY="' || STRING.sLOGMSG || '" VAR=LOGMSG'

    if (RC ~= 0) then

        call rcs_exit

    'QUERY FILE VAR=NAME'

    /* save to project directory */

    PATH = CONFIG.CFG_PATH || NAME

    'SAVE ALL FORCE EXPORT NAME="' || PATH || '"'

    if (exists(PATH) ~= 0) then do

        /* check in file */

        if (LOGMSG ~= "") then do

            if (REVISION ~= "") then
                'RUN DIR="' || CONFIG.CFG_PATH || '" OUTPUT="NIL:" CMD="rcs:ci *"-r' || REVISION || '*" *"-m' || LOGMSG || '*" *"' || PATH || '*""'
            else
                'RUN DIR="' || CONFIG.CFG_PATH || '" OUTPUT="NIL:" CMD="rcs:ci *"-m' || LOGMSG || '*" *"' || PATH || '*""'
        end
        else do

            if (REVISION ~= "") then
                'RUN DIR="' || CONFIG.CFG_PATH || '" OUTPUT="NIL:" CMD="rcs:ci *"-r' || REVISION || '*" *"' || PATH || '*""'
            else
                'RUN DIR="' || CONFIG.CFG_PATH || '" OUTPUT="NIL:" CMD="rcs:ci *"' || PATH || '*""'
        end

        /* successful ? */

        if (exists(PATH) = 0) then do

            /* delete file in work directory */

            'QUERY DOC VAR=PATH'

            'FILE DELETE FORCE NAME="' || PATH || '"'

            /* save copy to snapshot dir */

            if (CONFIG.CFG_SNAPSHOT ~= "") then do

                'BITS W=FALSE'

                'SAVE ALL FORCE EXPORT NAME="' || CONFIG.CFG_SNAPSHOT || NAME || '"'
            end

            /* clear buffer */

            'NEW NONAME FORCE'
        end
        else do

            'REQUEST BODY="' || STRING.sCHECKINERR || '" BUTTON="' || STRING.sOKVERBOSECANCEL || '"'

            if ((RC = 0) & (RESULT = 2)) then do

                /* try again (with output) */

                if (LOGMSG ~= "") then do

                    if (REVISION ~= "") then
                        'RUN DIR="' || CONFIG.CFG_PATH || '" CMD="rcs:ci *"-r' || REVISION || '*" *"-m' || LOGMSG || '*" *"' || PATH || '*""'
                    else
                        'RUN DIR="' || CONFIG.CFG_PATH || '" CMD="rcs:ci *"-m' || LOGMSG || '*" *"' || PATH || '*""'
                end
                else do

                    if (REVISION ~= "") then
                        'RUN DIR="' || CONFIG.CFG_PATH || '" CMD="rcs:ci *"-r' || REVISION || '*" *"' || PATH || '*""'
                    else
                        'RUN DIR="' || CONFIG.CFG_PATH || '" CMD="rcs:ci *"' || PATH || '*""'
                end
            end
        end
    end
    else
        'REQUEST PROBLEM="' || STRING.sSAVEERR || '"'

    return

/* /// */
