/* $VER: 1.0, 1998 Dietmar Eilert */

options results                             /* enable return codes     */

if (left(address(), 6) ~= "GOLDED") then    /* not started by GoldEd ? */

    address 'GOLDED.1'

'LOCK CURRENT RELEASE=4'                    /* lock GUI, gain access   */

if (RC ~= 0) then

    exit

options failat 6                            /* ignore warnings         */

signal on syntax                            /* ensure clean exit       */

/* ---------------------- INSERT YOUR CODE HERE ---------------------- */

'QUERY CAT'

if (RESULT = "deutsch") then do

    STRING.sERROR    = "Konnte SCMSG nicht starten !"
    STRING.sMODIFIED = "Datei wurde gendert. Speichern ?"
    STRING.sSAVE     = "!SPEICHERN|_Ignorieren|Abbre_chen"
    STRING.sNOFILE   = "Sourcecode nicht gefunden !"
end
else do

    STRING.sERROR    = "Could not start SCMSG !"
    STRING.sMODIFIED = "File has been modified. Save it ?"
    STRING.sSAVE     = "!SAVE|_Ignore|_Cancel"
    STRING.sNOFILE   = "Sourcecode not found !"
end

'QUERY MODIFY'

if (RESULT = "TRUE") then do

    'REQUEST TITLE="SAS/C" BODY="' || STRING.sMODIFIED || '" BUTTON="' || STRING.sSAVE || '"'

    if ((RESULT = 0) | (RC ~= 0)) then do

        'UNLOCK'

        exit
    end
    else if (RESULT = 1) then

        'SAVE ALL'
end

/* compile current file */

'QUERY DOC VAR=DOC'

if (exists(DOC)) then do

    'QUERY PATH VAR=PATH'

    EXENAME = ""

    /* read executable name from scoptions file */

    R = pragma('D', PATH)

    if (open('SCOPTIONS', 'scoptions', 'READ')) then do

        do until eof('SCOPTIONS')

            DATA = readln('SCOPTIONS')

            if (left(DATA, 11) = "PROGRAMNAME") then

                EXENAME = substr(DATA, 13)
        end

        R = close('SCOPTIONS')
    end

    if (EXENAME = "") then do

        /* choose executable name as text name minus suffix */

        'SUFFIX STRING="' || DOC || '" SUFFIX=""'

        EXENAME = RESULT

        /* text has no suffix ? */

        if (EXENAME = DOC) then do

            /* compile to /bin directory */

            if (right(PATH, 1) ~= ":") then

                PATH = PATH || "/"

            PATH = PATH || "bin/"

            if (exists(PATH) = 0) then

                'FILE NEWDIR NAME="' || PATH || '"'

            'QUERY FILE VAR=FILE'

            EXENAME = path || FILE
        end
    end

    /* remember executable name */

    'SET $sc/executable ' || EXENAME

    'FILE DELETE FORCE NAME="' || EXENAME || '"'

    /* run message browser */

    call run_scmsg

    /* compile file */

    'run ASYNC CMD="sc errorrexx link to *"' || EXENAME || '*" *"' || DOC || '*""'
end
else
    'REQUEST PROBLEM="' || STRING.sNOFILE || '"'

/* ------------------------- END OF YOUR CODE ------------------------ */

'UNLOCK'

exit

SYNTAX:

SAY "Error in line" SIGL ":" ERRORTEXT(RC)

'UNLOCK'

exit

/* /// "scmsg" */

run_scmsg: procedure EXPOSE PATH  STRING.

    'QUERY SCREEN VAR=PUBSCRNAME'

    if (~exists("env:sc")) then

        'FILE NEWDIR NAME="env:sc"'

    if (show('P', 'SC_SCMSG')) then do

        address SC_SCMSG 'opts screen ' || PUBSCRNAME
    end
    else do

        PORTNAME = ADDRESS()

        'EXPAND NAME="' || PATH || '" VAR=PATH'

        /* read and update (screen name, arexx port) scmsg config file */

        LINES = 0

        if open('SCMSG', 'env:sc/scmsg', 'READ') then do

            do until eof('SCMSG')

                DATA = readln('SCMSG')

                parse upper var DATA COMMAND .

                if ((COMMAND ~= "PORTNAME") & (COMMAND ~= "PUBSCREEN") & (COMMAND ~= "EDITCOMMAND") & (COMMAND ~= "GOTOFILE") & (COMMAND ~= "GOTOLINE")) then do

                    LINES = LINES + 1

                    CONFIG.LINES = DATA
                end

            end

            R = close('SCMSG')
        end

        /* generate new config file for scmsg (with current port/pubscreen name) */

        if open('SCMSG', 'env:sc/scmsg', 'WRITE') then do

            R = writeln('SCMSG', "PORTNAME " || PORTNAME          )
            R = writeln('SCMSG', "PUBSCREEN " || PUBSCRNAME       )
            R = writeln('SCMSG', "EDITCOMMAND golded:ed unnamed.c")
            R = writeln('SCMSG', "GOTOFILE WINDOW USE=%f FORCE"   )
            R = writeln('SCMSG', "GOTOLINE GOTO INDENT LINE=%l UNFOLD=TRUE")

            if (LINES ~= 0) then do

                do LINE=1 to (LINES - 1)

                    R = writeln('SCMSG', CONFIG.LINE)
                end
            end

            R = close('SCMSG')
        end

        /* run scmsg */

        'RUN ASYNC CMD="sc:c/scmsg" WAITPORT="SC_SCMSG" SECONDS=10 SHANGHAI=10 DIR="' || PATH || '"'

        if (RC ~= 0) then do

            'REQUEST PROBLEM="' || STRING.sERROR || '"'

            'UNLOCK'

            exit
        end

        'SET $sc/projdir "' || PATH || '"'

    end

    return

/* /// */
