/* $VER: 1.0, 1998 Dietmar Eilert */

options results                             /* enable return codes     */

if (left(address(), 6) ~= "GOLDED") then    /* not started by GoldEd ? */

    address 'GOLDED.1'

'LOCK CURRENT RELEASE=4'                    /* lock GUI, gain access   */

if (RC ~= 0) then

    exit

options failat 6                            /* ignore warnings         */

signal on syntax                            /* ensure clean exit       */

/* ---------------------- INSERT YOUR CODE HERE ---------------------- */

'QUERY CAT'

if (RESULT = "deutsch") then do

    STRING.sERROR    = "Konnte SCMSG nicht starten !"
    STRING.sSCOPTS   = "Projektkonfiguration nicht gefunden !"
    STRING.sNOLIB    = "rexxsupport.library nicht verfgbar !"
    STRING.sSRCFILE  = "Quellcode nicht gefunden !"
end
else do

    STRING.sERROR    = "Could not start SCMSG !"
    STRING.sSCOPTS   = "Project configuration not found !"
    STRING.sNOLIB    = "rexxsupport.library not availabale !"
    STRING.sSRCFILE  = "Source code not found !"
end

'QUERY PATH VAR=PATH'

'EXPAND NAME="' || PATH || '" VAR=PATH'

R = pragma('D', PATH)

/* read options file */

if (exists(SCOPTIONS)) then do

    if open('SCOPTIONS', 'scoptions', 'READ') then do

        GSTFILE="all.gst"

        do until eof('SCOPTIONS')

            DATA = readln('SCOPTIONS')

            if (left(DATA, 17) = "GLOBALSYMBOLTABLE") then

                GSTFILE = substr(DATA, 19)
        end

        R = close('SCOPTIONS')

        /* choose a source file for compilation */

        SRCFILE="gst.c"

        if (~exists(SRCFILE)) then

            SRCFILE = "makegst.c"

        if (~exists(SRCFILE)) then

            SRCFILE = "main.c"

        if (~exists(SRCFILE)) then do

            if (show('L', "rexxsupport.library") | addlib('rexxsupport.library', 0, -30, 0)) then do

                FILES = showdir(PATH, 'FILES')

                do while (FILES ~= "")

                    parse UPPER VAR FILES NEXT FILES

                    if (index(NEXT, ".C") ~= 0) then do

                        SRCFILE = NEXT

                        leave
                    end
                end

            end
            else
                'REQUEST PROBLEM="' || STRING.sNOLIB || '"'
        end

        if (exists(SRCFILE)) then do

            /* run message browser */

            call run_scmsg

            /* compile file */

            'FILE DELETE FORCE NAME="' || GSTFILE || '"'

            'run ASYNC CMD="sc errorrexx makegst=*"' || GSTFILE || '*" *"' || SRCFILE || '*""'
        end
        else
            'REQUEST PROBLEM="' || STRING.sSRCFILE || '"'
    end
end
else
    'REQUEST PROBLEM="' || STRING.sSCOPTS || '"'

/* ------------------------- END OF YOUR CODE ------------------------ */

'UNLOCK'

exit

SYNTAX:

SAY "Error in line" SIGL ":" ERRORTEXT(RC)

'UNLOCK'

exit

/* /// "scmsg" */

run_scmsg: procedure EXPOSE PATH  STRING.

    'QUERY SCREEN VAR=PUBSCRNAME'

    if (~exists("env:sc")) then

        'FILE NEWDIR NAME="env:sc"'

    if (show('P', 'SC_SCMSG')) then do

        address SC_SCMSG 'opts screen ' || PUBSCRNAME
    end
    else do

        PORTNAME = ADDRESS()

        'EXPAND NAME="' || PATH || '" VAR=PATH'

        /* read and update (screen name, arexx port) scmsg config file */

        LINES = 0

        if open('SCMSG', 'env:sc/scmsg', 'READ') then do

            do until eof('SCMSG')

                DATA = readln('SCMSG')

                parse upper var DATA COMMAND .

                if ((COMMAND ~= "PORTNAME") & (COMMAND ~= "PUBSCREEN") & (COMMAND ~= "EDITCOMMAND") & (COMMAND ~= "GOTOFILE") & (COMMAND ~= "GOTOLINE")) then do

                    LINES = LINES + 1

                    CONFIG.LINES = DATA
                end

            end

            R = close('SCMSG')
        end

        /* generate new config file for scmsg (with current port/pubscreen name) */

        if open('SCMSG', 'env:sc/scmsg', 'WRITE') then do

            R = writeln('SCMSG', "PORTNAME " || PORTNAME          )
            R = writeln('SCMSG', "PUBSCREEN " || PUBSCRNAME       )
            R = writeln('SCMSG', "EDITCOMMAND golded:ed unnamed.c")
            R = writeln('SCMSG', "GOTOFILE WINDOW USE=%f FORCE"   )
            R = writeln('SCMSG', "GOTOLINE GOTO INDENT LINE=%l UNFOLD=TRUE")

            if (LINES ~= 0) then do

                do LINE=1 to (LINES - 1)

                    R = writeln('SCMSG', CONFIG.LINE)
                end
            end

            R = close('SCMSG')
        end

        /* run scmsg */

        'RUN ASYNC CMD="sc:c/scmsg" WAITPORT="SC_SCMSG" SECONDS=10 SHANGHAI=10 DIR="' || PATH || '"'

        if (RC ~= 0) then do

            'REQUEST PROBLEM="' || STRING.sERROR || '"'

            'UNLOCK'

            exit
        end

        'SET $sc/projdir "' || PATH || '"'

    end

    return

/* /// */
