/* $VER: 1.0, 1998 Dietmar Eilert */

options results                             /* enable return codes     */

if (left(address(), 6) ~= "GOLDED") then    /* not started by GoldEd ? */

    address 'GOLDED.1'

'LOCK CURRENT RELEASE=4'                    /* lock GUI, gain access   */

if (RC ~= 0) then
    exit

options failat 6                            /* ignore warnings         */

signal on syntax                            /* ensure clean exit       */

/* ---------------------- INSERT YOUR CODE HERE ---------------------- */

'QUERY CAT'

if (RESULT = "deutsch") then do

    STRING.sSELECT = "Dieses Programm starten..."
end
else do

    STRING.sSELECT = "Run this executable ..."
end

'QUERY DOC  VAR=DOC'
'QUERY PATH VAR=PATH'

/* read executable name from scoptions file */

R = pragma('D', PATH)

if (open('SCOPTIONS', 'scoptions', 'READ')) then do

    do until eof('SCOPTIONS')

        DATA = readln('SCOPTIONS')

        if (left(DATA, 11) = "PROGRAMNAME") then

            EXENAME = substr(DATA, 13)
    end

    R = close('SCOPTIONS')
end

if (~exists(EXENAME)) then do

    /* choose executable as text name minus suffix */

    'SUFFIX STRING="' || DOC || '" SUFFIX=""'

    EXENAME = RESULT

    /* text name has no suffix ? */

    if (EXENAME = DOC) then do

        /* assume that there is a bin drawer */

        'QUERY FILE VAR=FILE'

        if (right(path, 1) ~= ":") then

            path = path || "/"

        EXENAME = PATH || "bin/" ||FILE
    end

    if (~exists(EXENAME)) then do

        /* read executable name set by compile.rexx macro */

        'QUERY $sc/executable VAR=EXENAME'

        if (~exists(EXENAME)) then do

            /* ask user for executable name */

            'QUERY PATH VAR=PATH'

            'REQUEST FILE TITLE="' || STRING.sSELECT || '" PATH="' || PATH || '" VAR=EXENAME'

            if ((EXENAME = "") | (RC ~= 0)) then do

                'UNLOCK'

                exit
            end

            /* save executable name */

            'SET $sc/executable ' || EXENAME
        end
    end
end

/* run executable */

if (exists(EXENAME)) then do

    'QUERY PATH VAR=PATH'

    'RUN ASYNC STACK=8192 CMD="*"' || EXENAME || '*"" DIR="' || PATH || '"'
end

/* ------------------------- END OF YOUR CODE ------------------------ */

'UNLOCK'

exit

SYNTAX:

SAY "Error in line" SIGL ":" ERRORTEXT(RC)

'UNLOCK'
