/* $VER: 1.0, 1998 Dietmar Eilert */

options results                             /* enable return codes     */

parse arg MOVEMENT .

if (left(address(), 6) ~= "GOLDED") then    /* not started by GoldEd ? */

    address 'GOLDED.1'

'LOCK CURRENT RELEASE=4'                    /* lock GUI, gain access   */

if (RC ~= 0) then

    exit

options failat 6                            /* ignore warnings         */

signal on syntax                            /* ensure clean exit       */

/* ---------------------- INSERT YOUR CODE HERE ---------------------- */

'QUERY CAT'

if (RESULT = "deutsch") then do

    STRING.sERROR   = "SCMSG-Browser wurde nicht gestartet."
    STRING.sNOERROR = "Keine Fehler in der Liste."
end
else do

    STRING.sERROR   = "SCMSG browser not running."
    STRING.sNOERROR = "No messages on the list."
end

if ~show('P', 'SC_SCMSG') then do

    'REQUEST PROBLEM="' || STRING.sERROR || '"'

    'UNLOCK'

    exit
end

PORTNAME = address()

address SC_SCMSG

/* send movement command to SCMSG */

if (MOVEMENT ~= "") then do

    options failat 35

    interpret MOVEMENT

    options failat 6
end

/* get name of main file from scmsg (there are no errors if there is no file name) */

'file'

FILE = RESULT

if (FILE = "") then do

    address VALUE PORTNAME

    'REQUEST PROBLEM="' || STRING.sNOERROR || '"'

    'UNLOCK'

    exit
end

/* get other details */

'text'

ERRTEXT = RESULT

'line'

LINE = RESULT

'number'

ERRNUM = RESULT

'altfile'

ALTFILE = RESULT

'altline'

ALTLINE = RESULT

address value PORTNAME

'FIX VAR=ERRTEXT'

/* process primary error message */

'WINDOW USE="' || FILE || '" FORCE'

if (RC = 0) then do

    'GOTO COLUMN=1 LINE=' || LINE || ' UNFOLD=TRUE'

    'GOTO INDENT'

    'REQUEST STATUS="' || ERRNUM || ': ' || ERRTEXT || '"'

end

/* process secondary error message */

if (ALTFILE ~= "") then do

    'WINDOW USE="' || ALTFILE || '" FORCE'

    if (RC = 0) then do

        'GOTO LINE=' || ALTLINE || ' UNFOLD=TRUE'

        'GOTO INDENT'

        'REQUEST STATUS="' || ERRNUM || ': ' || ERRTEXT || '"'

    end
end

/* ------------------------- END OF YOUR CODE ------------------------ */

'UNLOCK'

exit

SYNTAX:

SAY "Error in line" SIGL ":" ERRORTEXT(RC)

'UNLOCK'
