#include "defs.h"

/// "prototypes"

Prototype BOOL InitC(void);
Prototype void ExitC(void);

///
/// "init"

/* ----------------------------------- InitC -----------------------------------

 Library startup code (C entry point).

*/

BOOL
InitC(void)
{
    // open message port for sending asynchronous rexx messages

    if (AppContext.MsgPort = CreateMsgPort()) {

        AppContext.Outstanding = 0;

        return(TRUE);
    }
    else
        return(FALSE);
}

///
/// "exit"

/* ----------------------------------- ExitC -----------------------------------

 Library startup code (C entry point).

*/

void
ExitC(void)
{
    if (AppContext.MsgPort) {

        // wait until all messages sent to editor have been replied

        while (AppContext.Outstanding) {

            struct RexxMsg *msg;

            WaitPort(AppContext.MsgPort);

            while (msg = (struct RexxMsg *)GetMsg(AppContext.MsgPort)) {

                if (msg->rm_Node.mn_Node.ln_Type == NT_REPLYMSG) {

                    if (msg->rm_Result1 == RC_OK)

                        if (msg->rm_Result2)

                            DeleteArgstring((UBYTE *)msg->rm_Result2);

                    DeleteArgstring((UBYTE *)ARG0(msg));

                    DeleteRexxMsg(msg);

                    --AppContext.Outstanding;
                }
                else
                    ReplyMsg((struct Message *)msg);
            }
        }

        DeleteMsgPort(AppContext.MsgPort);

        AppContext.MsgPort = NULL;
    }
}

///
