/* -----------------------------------------------------------------------------

  Scan handler looking for assembler labes.
  
  Scan handlers are plain functions (loadSeg()'ed): no standard C startup
  code and no library calls permitted. We have to put string constants into
  the code segment (DICE compiler: option -ms1).

  DICE:
  
  dcc a68k.c -// -l0 -md -mRR -o golded:etc/scanner/a68k

  ------------------------------------------------------------------------------
*/

#include <exec/types.h>

ULONG
ScanHandlerA68k(__D0 ULONG len, __A0 char **text, __A1 ULONG *line)
{
    const char *version = "$VER: A68k 1.1 (" __COMMODORE_DATE__ ")";

    while (len && (**text == 32)) {

        ++*text;
        --len;
    }

    if ((len > 1) && (**text == '_'))
        return(len);
    else
        return(FALSE);
}

