/* -----------------------------------------------------------------------------

  Scan handler looking for #defines.
  
  Scan handlers are plain functions (loadSeg()'ed): no standard C startup
  code and no library calls permitted. We have to put string constants into
  the code segment (DICE compiler: option -ms1).

  DICE:
  
  dcc define.c -// -l0 -md -mRR -o golded:etc/scanner/defines

  ------------------------------------------------------------------------------
*/

#include <exec/types.h>

#define UPPER(a) ((a) & 95)

ULONG
ScanHandlerGuide(__D0 ULONG len, __A0 char **text, __A1 ULONG *line)
{
    const char *version = "$VER: Define 1.3 (" __COMMODORE_DATE__ ")";

    if (**text == '#') {

        if (len > 8) {

            UBYTE *next = *text + 1;

            if (UPPER(*next++) == 'D') {

                if (UPPER(*next++) == 'E') {

                    if (UPPER(*next++) == 'F') {

                        if (UPPER(*next++) == 'I') {

                            if (UPPER(*next++) == 'N') {

                                if (UPPER(*next++) == 'E') {

                                    if (*next++ == ' ') {

                                        UWORD letters = 0;

                                        for (len -= 8; (*next == 32) && len; --len)
                                            ++next;

                                        for (*text = next; len && (*next++ != ' '); --len)
                                            ++letters;

                                        return(letters);
                                    }
                                }
                            }
                        }
                    }
                }
            }
        }
    }

    return(FALSE);
}
